'February 2003, Alyce Watson
'Meteor Attack is an update of Asteroid Attack for LB3
'
'some sprites (c) Ari Feldman

[init] 'set up variables, load bitmaps:
    speed=5         'meteor moves this much each frame
    shipmove=14     'ship moves this much each frame
    shootactive=0   'no rocket is active
    maxexplode=10   'maximum number of frames for an explosion
    lx=300          'ship x location
    scrolly=1000    'background scroll y location
    list$=""        'list of sprites that collide
    sx=0:sy=0       'locations of sprites
    z=1             'index for sprite orientation

    dim Sizes(9)
        Sizes(9)=100                'total meteors that fall
        Sizes(0)=20                 'win if 20 meteors are destroyed
        Sizes(1)=DisplayWidth
        Sizes(2)=DisplayHeight
        Sizes(3)=DisplayWidth-40    'maximum playable width
        Sizes(4)=DisplayHeight+100  'hide location for meteors and explosions
        Sizes(5)=DisplayHeight-70   'location for ship
        Sizes(6)=0                  'score
        Sizes(7)=5                  'lives
        Sizes(8)=0                  'total meteors that hit earth

    dim Sprites(7)'6 meteors, #7=ship
    for i = 0 to 7
        Sprites(i)=maxexplode
    next i

    orient$(1)="normal"     'normal orientation
    orient$(2)="flip"       'show sprite flipped
    orient$(3)="mirror"     'show sprite mirrored
    orient$(4)="rotate180"  'show sprite rotated 180 degrees

'set up the timer:
    timer 2000, [loop]


nomainwin
    file$=DefaultDir$+"\stars2.jpg"
    open "jpeg.dll" for dll as #j
    file$=DefaultDir$+"\stars2.jpg"
    calldll #j, "LoadImageFile",0 as ulong,file$ as ptr,hStars as ulong
    file$=DefaultDir$+"\all4.bmp"
    calldll #j, "LoadImageFile",0 as ulong,file$ as ptr,hAll as ulong
    close #j

    if (hStars=0) or (hAll=0) then
        notice "Unable to load images."
        end
    end if

    loadbmp "stars", hStars   'the background
    loadbmp "all", hAll       '500x80 x 9 images - each 50x80
                              'and two images 25x40

'put large bitmap onscreen and carve into individual sprites:
[setup]
    WindowWidth=510:WindowHeight=150
    open "Setup" for graphics_nsb_nf as #1
    print #1, "drawbmp all      0 0;flush";
    print #1, "getbmp astr1     0 0 50 80";
    print #1, "getbmp astr2    50 0 50 80";
    print #1, "getbmp astr3   100 0 50 80";
    print #1, "getbmp sship   150 0 50 80";
    print #1, "getbmp exp1    200 0 50 80";
    print #1, "getbmp exp2    250 0 50 80";
    print #1, "getbmp exp3    300 0 50 80";
    print #1, "getbmp exp4    350 0 50 80";
    print #1, "getbmp exp5    400 0 50 80";
    print #1, "getbmp shoot1  450 0 25 40";
    print #1, "getbmp shoot2  475 0 25 40";
    close #1  'close setup window

'Open the game window, no titlebar or frames:
    WindowWidth = DisplayWidth:WindowHeight = DisplayHeight
    UpperLeftX  = 1  :UpperLeftY   = 1
    BackgroundColor$="black"
    ForegroundColor$="white"

    'note: statictext covers bottom strip of window:
    statictext #w.s, "Alt-F4 to Exit                 Score:",0,Sizes(2)-24,Sizes(1),24
    graphicbox #w.g, -1, -1, 802,602
    open "meteor Attack! - use numberpad to move and fire" for window_popup as #w
    print #w.g, "locate -1 -1 ";Sizes(1)+2;" ";Sizes(2)-20
    print #w, "refresh"
    print #w, "trapclose [quit]"

'set up sprites:  6 meteors, 1 ship
    print #w.g, "addsprite ast1 astr1";  'six meteors
    print #w.g, "addsprite ast2 astr2";
    print #w.g, "addsprite ast3 astr3";
    print #w.g, "addsprite ast4 astr1";
    print #w.g, "addsprite ast5 astr2";
    print #w.g, "addsprite ast6 astr3";
    print #w.g, "addsprite ship sship";  'user-controlled ship

'set up explosions and rocket, with multiple images:
    for i = 1 to 7
        print #w.g, "addsprite exp"+str$(i)+" exp1 exp2 exp3 exp4 exp5";
    next i
    print #w.g, "addsprite shoot shoot1 shoot2";           'rocket

'tell LB to cycle through images lists for explosions and rocket:
    for i = 1 to 7
        print #w.g, "cyclesprite exp"+str$(i)+" 1"
    next i
    print #w.g, "cyclesprite shoot 1"

'set automove for meteors:
    for i = 1 to 6
        print #w.g, "spritemovexy ast"+str$(i)+" 0 ";str$(i+4)
    next i

'set cloud image to be sprite background:
    print #w.g, "background stars";

'scale ship explosion to be large:
    print #w.g, "spritescale exp7 150";


    msg$="METEOR Attack!" + chr$(13)+ _
    "Save the planet!!"+chr$(13)+_
    "100 meteor hits will destroy the earth!"+chr$(13)+_
    "Destroy 20 meteors before earth is destroyed"+chr$(13)+_
    "and before you lose all of your lives to win."+chr$(13)+_
    "Use the numberpad or arrow keys to move and fire. "+chr$(13)+ _
    "4=left, 6=right, 5=stop and 8=shoot.  "+chr$(13) +_
    "Press Q to quit, or press Alt-F4 to close the window."+chr$(13)+ _
    "Some sprite images "+chr$(169)+" Ari Feldman."+chr$(13)+ _
    chr$(13)+"alycewatson@charter.net "+chr$(169)+" 2003"
    notice msg$

[begin]
'set beginning locations for active sprites:
    print #w.g, "spritexy ast1  470 5";
    print #w.g, "spritexy ast2  60  20";
    print #w.g, "spritexy ast3  520 0";
    print #w.g, "spritexy ast4  10 5";
    print #w.g, "spritexy ast5  400  20";
    print #w.g, "spritexy ast6  120 0";
    print #w.g, "spritexy ship ";lx;"  ";Sizes(5)

'set beginning locations for inactive sprites - out of sight
'shooter and explosions:
    print #w.g, "spritexy shoot 0  ";Sizes(2)+200

    for i = 1 to 7
        print #w.g, "spritexy exp"+str$(i)+" 0  ";Sizes(2)+100
    next i
    print #w.s, "Alt-F4 to Exit                 Score:   " + str$(Sizes(6)) +"     Lives:  " + str$(Sizes(7)) + "     Earth hits:   "+str$(Sizes(8))

'reset timer for play:
    timer 100, [drawFrame]

[loop]
    print #w.g, "setfocus; when characterInput [charCheck]";
    scan
    WAIT


[charCheck] 'program goes here when user hits a key:
    k$=Inkey$
    if upper$(k$)="Q" then [quit]

    if Sprites(7)<maxexplode then [loop] 'you are exploding and cannot move
    if k$="6" or asc(right$(k$,1))=39 then [right]
    if k$="4" or asc(right$(k$,1))=37 then [left]
    if k$="5" or asc(right$(k$,1))=40 then [stop]
    if k$="8" or asc(right$(k$,1))=38 then [shoot]
    wait

'this routine is fired by the timer -- all game action comes from this:
[drawFrame]
    gosub [checkAst]       'check positions of meteors
    gosub [checkRocket]    'check rocket
    gosub [moveShip]       'move your ship
    gosub [doFrame]        'do the drawing
    gosub [checkCollide]   'see if any sprites touch
    gosub [checkGameOver]  'see if you are out of lives
    wait                   'wait for timer to fire again


'The following routines are called from [drawFrame]:
[checkAst]'check position of 6 meteors, reset if they go offscreen:
    for i = 1 to 6
        Sprites(i)=Sprites(i)+1
            if Sprites(i)>maxexplode then
                print #w.g, "spritexy? ast"+str$(i)+" sx sy";
                    if sy>Sizes(2) then call Resetmeteor "ast"+str$(i), "exp"+str$(i)
            end if
    next i
    RETURN

sub Resetmeteor astnum$, expnum$  'reset meteor and its explosion
    sx=int(rnd(0)*Sizes(3))       'reset x location
    scale=int(rnd(0)*100)+50      'reset size
    speed=int(rnd(0)*15)+16       'reset speed
    z=int(rnd(0)*4)+1             'change orientation
    Sizes(8)=Sizes(8)+1
    print #w.g, "spriteorient ";astnum$;" ";orient$(z)
    print #w.g, "spritemovexy ";astnum$;" 0 ";speed
    print #w.g, "spritexy ";astnum$;" ";sx;" 0";
    print #w.g, "spritescale ";astnum$;" ";scale
    print #w.g, "spritescale ";expnum$;" ";scale
    print #w.g, "spriteorient ";expnum$;" ";orient$(z)
    print #w.s, "Alt-F4 to Exit                 Score:   " + str$(Sizes(6)) +"     Lives:  " + str$(Sizes(7)) + "     Earth hits:   "+str$(Sizes(8))
    end sub



[checkRocket] 'check position of rocket, reset if necessary
    if shootactive=0 then return
    print #w.g, "spritexy? shoot x y";
    'if rocket goes off screen, move out of sight, stop movement, reset flag
    if y<12 then
        shootactive=0
        print #w.g, "spritemovexy shoot 0 0";
        print #w.g, "spritexy shoot 0 ";Sizes(2)+200
    end if
    return


[moveShip] 'ship position is changed by programmer for each frame:
    lx=lx+shipspeed
    if lx<0 then lx=Sizes(1)-20
    if lx>Sizes(1)-20 then lx=0
    Sprites(7)=Sprites(7)+1 'ship explosion counter
    return


[doFrame]  'update screen - meteors and rockets move automatically
    scrolly=scrolly-10
    print #w.g, "backgroundxy 0 ";scrolly
    print #w.g, "spritexy ship ";lx;" ";Sizes(5)
    print #w.g, "drawsprites";
    return


[checkCollide] 'see if any sprites collide
    gosub [checkExplosions]

    'check for rocket hitting meteors:
    if shootactive = 1 then
        print #w.g, "spritecollides shoot list$";
        if list$ <> "" and instr(list$, "ast")>0 then gosub [rocketmeteorCollide]
    end if

    'check for ship hitting meteors:
    if Sprites(7)<maxexplode then return    'ship is still exploding
    print #w.g, "spritecollides ship list$";
    if instr(list$, "ast") > 0 then gosub [shipmeteorCollide]
    return


[checkGameOver] 'You're dead, Jim!
    if Sprites(7)>=maxexplode and Sizes(7)<=0 then [quit]
    if Sizes(8)>Sizes(9) then [earthGone]
    if Sizes(6)>=Sizes(0) then [youWin] 'you have destroyed enough meteors to win
    RETURN


'The following routines are called from [checkCollide]:
[checkExplosions]'check condition of explosions, reset as necessary
    if Sprites(7)=maxexplode then 'turn off explosion, activate ship
        print #w.g, "spritevisible ship on";  'make ship visible again
        print #w.g, "spritexy exp7 0 ";Sizes(2)+100  'move explosion out of sight
    end if

    for i = 1 to 6
        if Sprites(i)=maxexplode then call StopExplosion "ast"+str$(i), "exp"+str$(i)
    next i

    RETURN

sub StopExplosion astnum$, expnum$
    print #w.g, "spritexy ";expnum$;" 0 ";Sizes(4)    'move out of sight
    print #w.g, "spritemovexy ";astnum$;"  0 10"  'reset automove
    end sub


[rocketmeteorCollide] 'rocket has hit one of the meteors
'move meteor that was hit out of sight, stop it from moving
'and turn on its explosion, at the current meteor position
'(explosions are active if flag values are under maxexplode value)

    for i = 1 to 6
        if instr(list$, "ast"+str$(i))>0 then
            call StartExplosion "exp"+str$(i), "ast"+str$(i)
            Sprites(i)=0                           'meteor explosion active
        end if
    next i

    print #w.g, "spritexy shoot 0 ";Sizes(2)+200 'move rocket out of sight
    print #w.g, "spritemovexy shoot  0 0"       'stop automove
    playwave "boom.wav", async
    gosub [destroy]
    RETURN



sub StartExplosion expnum$,astnum$
    print #w.g, "spritexy? ";astnum$;" sx sy";     'get location of meteor
    print #w.g, "spritexy ";expnum$;" ";sx;" ";sy  'move explosion to this location
    print #w.g, "spritexy ";astnum$;" 0 ";Sizes(4) 'move meteor out of sight
    print #w.g, "spritemovexy ";astnum$;" 0 0"     'stop automove
    end sub



[shipmeteorCollide] 'an meteor has collided with the spaceship
'move the meteor out of sight, so it will be reset for next frame
'(if meteor y > DisplayHeight it will be reset for the next frame)

    for i = 1 to 6
        if instr(list$, "ast"+str$(i))>0 then
            print #w.g, "spritexy ast"+str$(i)+" 0 ";Sizes(2)+300
            i=6
        end if
    next i

    playwave "boom.wav", async
    gosub [die]
    RETURN



'The following routine is called from [rocketmeteorCollide]:
[destroy] 'explode meteor, remove rocket
    Sizes(6)=Sizes(6)+1
    shootactive=0   'rocket is no longer active
    print #w.g, "spritexy shoot 0 ";Sizes(2)+200  'move rocket out of sight
    print #w.s, "Alt-F4 to Exit                 Score:   " + str$(Sizes(6)) +"     Lives:  " + str$(Sizes(7)) + "     Earth hits:   "+str$(Sizes(8))
    RETURN


'The following routine is called from [shipmeteorCollide]:
[die] 'activate ship explosion
    Sizes(7)=Sizes(7)-1
    Sprites(7)=1     'your ship is exploding
    print #w.s, "Alt-F4 to Exit                 Score:   " + str$(Sizes(6)) +"     Lives:  " + str$(Sizes(7)) + "     Earth hits:   "+str$(Sizes(8))
    print #w.g, "spritevisible ship off";       'hide ship until explosion finishes
    print #w.g, "spritexy? ship sx sy";         'get location of ship
    print #w.g, "spritexy exp7 ";sx;" ";sy      'place explosion in this location
    shipspeed=0     'don't move while exploding
    RETURN


'These routines are activated when user hits numberpad keys:
[left] 'Key 4 -- make ship move left:
    shipspeed = (-1) * shipmove
    goto [loop]

[right]'Key 6 -- make ship move right
    shipspeed = shipmove
    goto [loop]

[stop]'Key 5 -- make ship stop in place
    shipspeed = 0
    goto [loop]

[shoot] 'Key 8 -- get location of ship and activate rocket
        'can only shoot if no shot is already active:
    if shootactive=0 then
        print #w.g, "spritexy? ship sx sy";           'get location of ship
        print #w.g, "spritexy shoot ";sx+12;" ";Sizes(5) 'start rocket at center of ship top
        print #w.g, "spritemovexy shoot 0 -10"        'active automove
        shootactive=1                                 'flag for rocket active
        playwave "laser.wav",async
    end if
    goto [loop]

[earthGone]
    timer 0  'pause play
    confirm "Earth has been destroyed, but you destroyed "+str$(Sizes(6))+" meteors!  Play again?";answer$
    if answer$="yes" then
        Sizes(7)=5
        Sizes(6)=0
        Sizes(8)=0
        print #w.s, "Alt-F4 to Exit                 Score:   " + str$(Sizes(6)) +"     Lives:  " + str$(Sizes(7)) + "     Earth hits:   "+str$(Sizes(8))
        lx=300
        goto [begin]
    END IF
    goto [exit]

[youWin]
    timer 0  'pause play
    confirm "Earth has been Saved! You destroyed "+str$(Sizes(6))+" meteors!  Play again?";answer$
    if answer$="yes" then
        Sizes(7)=5
        Sizes(6)=0
        Sizes(8)=0
        print #w.s, "Alt-F4 to Exit                 Score:   " + str$(Sizes(6)) +"     Lives:  " + str$(Sizes(7)) + "     Earth hits:   "+str$(Sizes(8))
        lx=300
        goto [begin]
    END IF
    goto [exit]

[quit] 'Key Q -- end program
    timer 0  'pause play
    confirm "You destroyed "+str$(Sizes(6))+" meteors!  Play again?";answer$
    if answer$="yes" then
        Sizes(7)=5
        Sizes(6)=0
        Sizes(8)=0
        print #w.s, "Alt-F4 to Exit                 Score:   " + str$(Sizes(6)) +"     Lives:  " + str$(Sizes(7)) + "     Earth hits:   "+str$(Sizes(8))
        lx=300
        goto [begin]
    END IF

[exit]
    unloadbmp "stars"
    unloadbmp "all"
    unloadbmp "astr1"
    unloadbmp "astr2"
    unloadbmp "astr3"
    unloadbmp "sship"
    unloadbmp "exp1"
    unloadbmp "exp2"
    unloadbmp "exp3"
    unloadbmp "exp4"
    unloadbmp "exp5"
    unloadbmp "shoot1"
    unloadbmp "shoot2"
    close #w:end




